#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# Copyright 2014
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc,xbmcaddon,HTMLParser,sys
from tools import *
from xbmcgui import ListItem
from BeautifulSoup import BeautifulSoup



versao = '0.0.1'
addon_id = 'plugin.video.filmesonlinebr'
selfAddon = xbmcaddon.Addon(id=addon_id)
addonfolder = selfAddon.getAddonInfo('path')
artfolder = addonfolder + '/resources/img/'
fanart = addonfolder + '/fanart.jpg'
site_base = 'http://www.filmesonlinebr.net'


def Menu_Principal():
	addDir('Categorias','-',1,artfolder + 'categorias.jpg')
	addDir('Ultimos Adicionados',site_base,2,artfolder + 'ultimos.jpg')
	addDir('Séries',site_base + '/series/',5,artfolder + 'series.jpg')
	addDir('Pesquisar','-',4,artfolder + 'pesquisa.jpg')
	xbmcplugin.setContent(int(sys.argv[1]), 'movies')
	xbmc.executebuiltin('Container.SetViewMode(502)')

def Listar_categorias(url):
	addDir('Acão','http://www.filmesonlinebr.net/acao/',2,artfolder + 'acao.jpg')
	addDir('Animação','http://www.filmesonlinebr.net/animacao/',2,artfolder + 'animacao.jpg')
	addDir('Aventura','http://www.filmesonlinebr.net/aventura/',2,artfolder + 'aventura.jpg')
	addDir('Comédia','http://www.filmesonlinebr.net/comedia/',2,artfolder + 'comedia.jpg')
	addDir('Comédia Romantica','http://www.filmesonlinebr.net/comedia-romantica/',2,artfolder + 'comediaro.jpg')
	addDir('Documentários','http://www.filmesonlinebr.net/documentarios/',2,artfolder + 'doc.jpg')
	addDir('Drama','http://www.filmesonlinebr.net/drama/',2,artfolder + 'drama.jpg')
	addDir('Esporte','http://www.filmesonlinebr.net/esporte/',2,artfolder + 'esportes.jpg')
	addDir('Faroeste','http://www.filmesonlinebr.net/faroeste/',2,artfolder + 'faroeste.jpg')
	addDir('Ficção Científica','http://www.filmesonlinebr.net/ficcao-cientifica/',2,artfolder + 'fic.jpg')
	addDir('Gospel','http://www.filmesonlinebr.net/gospel/',2,artfolder + 'gospel.jpg')
	addDir('Guerra','http://www.filmesonlinebr.net/guerra/',2,artfolder + 'guerra.jpg')
	addDir('Infantil','http://www.filmesonlinebr.net/infantil/',2,artfolder + 'infantil.jpg') 
	addDir('Musical','http://www.filmesonlinebr.net/musical/',2,artfolder + 'musical.jpg')
	addDir('Nacional','http://www.filmesonlinebr.net/nacional/',2,artfolder + 'nacional.jpg')
	addDir('Policial','http://www.filmesonlinebr.net/policial/',2,artfolder + 'policial.jpg') 
	addDir('Romance','http://www.filmesonlinebr.net/romance/',2,artfolder + 'romance.jpg')
	addDir('Suspense','http://www.filmesonlinebr.net/suspense/',2,artfolder + 'suspense.jpg')
	addDir('Terror','http://www.filmesonlinebr.net/terror/',2,artfolder + 'terror.jpg')
	addDir('Thriller','http://www.filmesonlinebr.net/thriller/',2,artfolder + 'thriller.jpg')
	xbmcplugin.setContent(int(sys.argv[1]), 'movies')
	xbmc.executebuiltin('Container.SetViewMode(500)')

def Listar_videos(url):
    codigo_fonte = abrir_url(url)

    soup = BeautifulSoup(abrir_url(url))
    lista_filmes = BeautifulSoup(soup.find("div", { "class" : "post" }).prettify())
    resultados = lista_filmes.findAll("li")
    a=[]
    for resultado in resultados:
	    try:
		temp = [resultado.a["href"],"%s (%s)" % (resultado.h2.text.encode('ascii', 'ignore'),resultado.span.text),resultado.text.encode('ascii', 'ignore'),resultado.img["src"]] 
		a.append(temp)
	    except:
		temp = [resultado.a["href"],"%s" % (resultado.h2.text.encode('ascii', 'ignore')),resultado.text.encode('ascii', 'ignore'),resultado.img["src"]] 
		a.append(temp)
	    
    total = len(a)
    for url2, titulo, plot, img in a:
	    titulo = titulo.replace('&#8211;',"-").replace('&#8217;',"'")	
	    addDir(titulo,url2,3,img,False,total,plot)


    pages = soup.findAll("a",{ "class" : "nextpostslink" })
    for prox_pagina in pages:
	    addDir('Página Seguinte >>',prox_pagina["href"],2,artfolder + 'prox.jpg')
	    break
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmc.executebuiltin('Container.SetViewMode(500)')
    
def Listar_series(url):
    codigo_fonte = abrir_url(url)

    soup = BeautifulSoup(abrir_url(url))
    lista_filmes = BeautifulSoup(soup.find("div", { "class" : "post" }).prettify())
    resultados = lista_filmes.findAll("li")
    a=[]
    for resultado in resultados:
	    try:
		temp = [resultado.a["href"],"%s (%s)" % (resultado.h2.text.encode('ascii', 'ignore'),resultado.span.text),resultado.text.encode('ascii', 'ignore'),resultado.img["src"]] 
		a.append(temp)
	    except:
		temp = [resultado.a["href"],"%s" % (resultado.h2.text.encode('ascii', 'ignore')),resultado.text.encode('ascii', 'ignore'),resultado.img["src"]] 
		a.append(temp)
	    
    total = len(a)
    for url2, titulo, plot, img in a:
	    titulo = titulo.replace('&#8211;',"-").replace('&#8217;',"'")	
	    addDir(titulo,url2,6,img,True,total,plot)


    pages = soup.findAll("a",{ "class" : "nextpostslink" })
    for prox_pagina in pages:
	    addDir('Página Seguinte >>',prox_pagina["href"],5,artfolder + 'prox.jpg')
	    break
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmc.executebuiltin('Container.SetViewMode(500)')

def Listar_episodios(url):
    a = []
    codigo_fonte = abrir_url(url)

    soup = BeautifulSoup(abrir_url(url))
    lista_episodios = BeautifulSoup(soup.find("div", { "class" : "player-video" }).prettify())
    dublados = lista_episodios.findAll("div", { "class" : "left-series" })
    for dublado in dublados:
	temporada = dublado.strong.text.encode('ascii', 'ignore')
	for ep in dublado.findAll("a"):
	    temp = [ep["href"], temporada + "-" + ep.text.encode('ascii', 'ignore'), '','']
	    a.append(temp)
    total = len(a)
    for url2, titulo, plot, img in a:
	    titulo = titulo.replace('&#8211;',"-").replace('&#8217;',"'")	
	    addDir(titulo,url2,3,img,False,total,plot)
	    

def obtem_url_firedrive(url):
	import mechanize, cookielib
	
	br = mechanize.Browser()

	cj = cookielib.LWPCookieJar()
	br.set_cookiejar(cj)
	
	br.set_handle_equiv(True)
	br.set_handle_gzip(True)
	br.set_handle_redirect(True)
	br.set_handle_referer(True)
	br.set_handle_robots(False)
	
	br.set_handle_refresh(mechanize._http.HTTPRefreshProcessor(), max_time=1)
	
	br.addheaders = [('User-agent', 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.1) Gecko/2008071615 Fedora/3.0.1-1.fc9 Firefox/3.0.1'),("Referer","http://www.firedrive.com")]
	br.open(url)
	br.select_form(nr=0)
	response1 = br.submit()
	html = response1.read()
	
	video_url = re.findall(r"file:.'(.*?)',",html)[0]
	return [video_url,"-"]

def obtem_url_dropvideo(url):
	codigo_fonte = abrir_url(url)
	try:
		if not 'dropvideo.com/embed/' in url:
			id_video = re.findall(r'<iframe src="http://www.dropvideo.com/embed/(.*?)/"',codigo_fonte)[0]
			codigo_fonte = abrir_url('http://www.dropvideo.com/embed/%s/' % id_video)
			url_video = re.findall(r'var vurl2 = "(.*?)";',codigo_fonte)[0]
			url_legendas =	re.compile('var vsubtitle = "(.*?)";').findall(codigo_fonte)[0]
		else:
			codigo_fonte = abrir_url(url)
			url_video = re.findall(r'var vurl2 = "(.*?)";',codigo_fonte)[0]
			url_legendas =	re.compile('var vsubtitle = "(.*?)";').findall(codigo_fonte)[0]
	except:
		url_video = '-'
		url_legendas = '-'
	return [url_video,url_legendas]

def obtem_url_vidig(url):
    codigo_fonte = abrir_url(url)
    ow = open("C:\\Python27\\vidig.html", "w")
    ow.write(codigo_fonte)
    ow.close()
    url = re.findall(r'file=(.*?)&',codigo_fonte)[0]
    return [url,'-']



def Player(name,url,iconimage):
	
	dropvideo = r'http://www.player3k.info/dropvideo/.id=(.*?)"'
	firedrive = r'src="http://www.player3k.info/putlocker/.id=(.*?)"'
	
	mensagemprogresso = xbmcgui.DialogProgress()
	mensagemprogresso.create('FilmesOnlineBR', 'A resolver link','Por favor aguarde...')
	mensagemprogresso.update(33)
	
	links = []
	hosts = []
	matriz = []

	codigo_fonte = abrir_url(url)

	try:
	    links.append('http://www.dropvideo.com/embed/'+re.findall(dropvideo, codigo_fonte)[0])
	    hosts.append('Dropvideo')
	except:
		pass
	try:
	    links.append('http://www.firedrive.com/embed/'+re.findall(firedrive, codigo_fonte)[0])
	    hosts.append('Firedrive')
	except:
		pass

	if not hosts:
		return
	
	index = xbmcgui.Dialog().select('Selecione um dos hosts suportados :', hosts)

	if index == -1:
		return

	url_video = links[index]
	mensagemprogresso.update(66)
	
	print 'Player url: %s' % url_video

	if 'dropvideo.com/embed' in url_video:
		matriz = obtem_url_dropvideo(url_video)   # esta linha está a mais
	elif 'firedrive.com/embed' in url_video:
		matriz = obtem_url_firedrive(url_video)
	else:
		print "Falha: " + str(url_video)

	print matriz
	url = matriz[0]
	print url
	if url=='-': return
	legendas = matriz[1]
	print "Url do gdrive: " + str(url_video)
	print "Legendas: " + str(legendas)
	
	mensagemprogresso.update(100)
	mensagemprogresso.close()
	
	listitem = xbmcgui.ListItem() # name, iconImage="DefaultVideo.png", thumbnailImage="DefaultVideo.png"
	listitem.setPath(url)
	listitem.setProperty('mimetype','video/mp4')
	listitem.setProperty('IsPlayable', 'true')
	#try:
	xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
	xbmcPlayer.play(url)
	if legendas != '-':
		if 'timedtext' in legendas:
			#legenda = xmltosrt.convert(legendas)
			#try:
				import os.path
				sfile = os.path.join(xbmc.translatePath("special://temp"),'sub.srt')
				sfile_xml = os.path.join(xbmc.translatePath("special://temp"),'sub.xml')#timedtext
				sub_file_xml = open(sfile_xml,'w')
				sub_file_xml.write(urllib2.urlopen(legendas).read())
				sub_file_xml.close()
				print "Sfile.srt : " + sfile_xml
				xmltosrt.main(sfile_xml)
				xbmcPlayer.setSubtitles(sfile)
			#except:
			#	pass
		else:
			xbmcPlayer.setSubtitles(legendas)

def Pesquisa():
	keyb = xbmc.Keyboard('', 'Pesquisar...')
	keyb.doModal()
	if (keyb.isConfirmed()):
		search = keyb.getText()
		parametro_pesquisa=urllib.quote(search)
		url = 'http://www.filmesonlinebr.net/?s=' + str(parametro_pesquisa)
		Listar_videos(url)



################################################
#    Funções relacionadas a media.             #
#                                              #
################################################

def addLink(name,url,iconimage):
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="Video", infoLabels={ "Title": name } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
	return ok

def addDir(name,url,mode,iconimage,pasta=True,total=1,plot=''):
	u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="video", infoLabels={ "title": name, "plot": plot } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=pasta,totalItems=total)
	return ok




################################################
#    Pega os parametros                        #
#                                              #
################################################

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

      
params=get_params()
url=None
name=None
mode=None
iconimage=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

try:        
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass


print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Iconimage: "+str(iconimage)

################################################
#    Destina para cada modo.                   #
#                                              #
################################################

if mode==None or url==None or len(url)<1:
        print "Sem mode"
        print "Inicio: Menu Principal"
        Menu_Principal()

elif mode==1:
	print "Mode: 1 - Listar Categorias"
	Listar_categorias(url)
	
elif mode==2:
	print "Mode: 2 - Listar Videos"
	Listar_videos(url)

elif mode==3:
	print "Mode: 3 - Player"
	Player(name,url,iconimage)

elif mode==4:
	print 'Mode: 4 - Pesquisa'
	Pesquisa()

elif mode==5:
	print 'Mode: 5 - Listar Series'
	Listar_series(url)

elif mode==6:
	print 'Mode: 6 - Listar Episodios'
	Listar_episodios(url)

xbmcplugin.endOfDirectory(int(sys.argv[1]))